package BPpackage;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.RadioButton;
import android.widget.TextView;
import android.widget.Toast;
import java.lang.Runnable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import BPpackage.dialogs.*;


public class Dialogs extends ListActivity {

	public PRAFileHandler fhandler = new PRAFileHandler(this);
	public Map<String, String> dbs = new HashMap<String, String>();
	public HashMap<String, String[]> dict = new HashMap<String, String[]>();
	public String tizi = "jian";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		buildDict();
		setContentView(R.layout.activity_dialogs);
	}


	private void buildDict(){
		String[] db = fhandler.getAssetAsArray("ruzhechu.db");
		String[] tokens;
		for (String l : db){
			while (l.contains("\t\t")){
				l = l.replace("\t\t", "\t");
			}
			tokens = l.split("\t");
			if (tokens.length < 4 ){ return; }
			String fan;
			if (tokens[2].trim().matches("-")){
					fan = tokens[1];
			} else {
				fan = tokens[2];
			}
			String[] entries = { tokens[1], fan };
			dict.put(tokens[4], entries);
		}
	}


	/**
	 * call on resume when list is altered
	 **/
	@Override
	public void onResume() {
		super.onResume();

		final String[] list = buildList();
		setListAdapter(new ArrayAdapter<String>(this,
				R.layout.pra_list_item, list));

		EdgeEffectListView listView = (EdgeEffectListView) getListView();
		listView.setTextFilterEnabled(true);
		registerForContextMenu(listView);

		listView.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view,
					int position, long id) {
				String result = ((TextView) view).getText().toString();
				String num = dbs.get(result);
				startDialog(num, position);
			}
		});
	}

	public void onRadioButtonClicked(View view) {
		boolean checked = ((RadioButton) view).isChecked();
		switch(view.getId()) {
        case R.id.fan:
            if (checked)
                tizi = "fan";
				break;
        case R.id.jian:
            if (checked)
                tizi = "jian";
				break;
		}
	}

	private void startDialog(String num, int pos){
		Intent intent = new Intent(this, Dialog.class);
		intent.putExtra("NUM", num);
		intent.putExtra("TIZI", tizi);
		intent.putExtra("POS", pos);
		intent.putExtra("DICT", dict);
		startActivity(intent);
	}

	private String[] buildList() {
		List<String> alist = new ArrayList<String>();
		String[] files = fhandler.listAssets(".txt");
		String name = "";
		String num = "";
		alist = new ArrayList<String>();
		for (String f : files) {
			name = f.replace('_', ' ');
			name = name.replace(".txt", "");
			// TODO locale for next line
			name = Character.toUpperCase(name.charAt(0)) + name.substring(1);
			alist.add(name);
			num = name.split(" ")[1];
			dbs.put(name, num);
		}

		Collections.sort(alist);
		String[] list = new String[alist.size()];
		alist.toArray(list);
		return list;
	}

	private void triggerDialog(){
		Intent intent = new Intent(this, Dialog.class);
		startActivity(intent);
	}


	private boolean doubleBackPressedOnce = false;

	@Override
	public void onBackPressed() {
		if (doubleBackPressedOnce) {
			super.onBackPressed();
			return;
		}
		doubleBackPressedOnce = true;
		Toast.makeText(this, R.string.exit_bkbtn, Toast.LENGTH_SHORT).show();
		new Handler().postDelayed(new Runnable() {

			@Override
			public void run() {
				doubleBackPressedOnce = false;
			}
		}, 2000);
	}

}
